-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["PALADIN"] = {}
lib.classes["PALADIN"][2] = function ()
	cfg.spells={}
	lib.AddSpell("ShoR",{53600}) -- Shield of the Righteous
	lib.AddSpell("CS",{35395}) -- Crusader Strike
	lib.AddSpell("J",{20271}) -- Judgement
	lib.AddSpell("HoW",{24275}) -- Hammer of Wrath
	lib.AddSpell("AS",{31935}) -- Avenger's Shield
	lib.AddSpell("Con",{26573}) -- Consecration
	lib.AddSpell("HW",{2812}) -- Holy Wrath
	lib.AddSpell("SoT",{31801}) -- Seal of Truth
	lib.AddSpell("HotR",{53595}) -- Hammer of the Righteous
					
	cfg.auras={}
	lib.AddAura("SoI",20165,"buff","player") -- Seal of Insigh
	lib.AddAura("SoR",20154,"buff","player") -- Seal of Righteousness
	lib.AddAura("SoT",31801,"buff","player") -- Seal of Truth
			
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Seal")
	table.insert(cfg.plistdps,"ShoR")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"J")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"AS")
	table.insert(cfg.plistdps,"Con")
	table.insert(cfg.plistdps,"HW")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Seal")
	table.insert(cfg.plistaoe,"HotR")
	table.insert(cfg.plistaoe,"Con")
	table.insert(cfg.plistaoe,"HW")
	table.insert(cfg.plistaoe,"AS")
	table.insert(cfg.plistaoe,"ShoR")
	table.insert(cfg.plistaoe,"J")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["Seal"] = function ()
			local t = lib.GetAura({"SoI","SoR","SoT"})
			if t<3 then
				return lib.SimpleCDCheck("SoT")
			end
			return nil
		end,
		["ShoR"] = function()
			if cfg.holy==3 then
				return lib.SimpleCDCheck("ShoR")
			end
			return nil
		end,
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
		end,
	}
	return true
end

lib.classes["PALADIN"][3] = function ()
	cfg.spells={}
--	lib.AddSpell("ShoR",{53600}) -- Shield of the Righteous
	lib.AddSpell("Inq",{84963}) -- Inquisition
	lib.AddSpell("CS",{35395}) -- Crusader Strike
	lib.AddSpell("J",{20271}) -- Judgement
	lib.AddSpell("HoW",{24275}) -- Hammer of Wrath
	lib.AddSpell("AS",{31935}) -- Avenger's Shield
	lib.AddSpell("Con",{26573}) -- Consecration
	lib.AddSpell("HW",{2812}) -- Holy Wrath
	lib.AddSpell("SoT",{31801}) -- Seal of Truth
	lib.AddSpell("HotR",{53595}) -- Hammer of the Righteous
	lib.AddSpell("Exo",{879}) -- Exorcism
	lib.AddSpell("TV",{85256}) -- Templar's Verdict
	lib.AddSpell("DS",{53385}) -- Divine Storm
	
	cfg.auras={}
	lib.AddAura("SoI",20165,"buff","player") -- Seal of Insigh
	lib.AddAura("SoR",20154,"buff","player") -- Seal of Righteousness
	lib.AddAura("SoT",31801,"buff","player") -- Seal of Truth
	lib.AddAura("AoW",59578,"buff","player") -- The Art of War
	lib.AddAura("DivPurp",90174,"buff","player") -- Divine Purpose
	lib.AddAura("Inq",84963,"buff","player") -- Inquisition
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Seal")
	table.insert(cfg.plistdps,"Inq")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"Exo")
	table.insert(cfg.plistdps,"TV")
	table.insert(cfg.plistdps,"J")
	table.insert(cfg.plistdps,"HW")
	table.insert(cfg.plistdps,"Con")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Seal")
	table.insert(cfg.plistaoe,"Inq")
	table.insert(cfg.plistaoe,"DS")
	table.insert(cfg.plistaoe,"HoW")
	table.insert(cfg.plistaoe,"Exo")
	table.insert(cfg.plistaoe,"TV")
	table.insert(cfg.plistaoe,"J")
	table.insert(cfg.plistaoe,"Con")
	table.insert(cfg.plistaoe,"HW")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["Seal"] = function ()
			local t = lib.GetAura({"SoI","SoR","SoT"})
			if t<3 then
				return lib.SimpleCDCheck("SoT")
			end
			return nil
		end,
		["TV"] = function()
			if cfg.holy==3 or lib.GetAura({"DivPurp"})>0 then
				return lib.SimpleCDCheck("TV")
			end
			return nil
		end,
		["CS"] = function()
			if cfg.holy<3 then
				return lib.SimpleCDCheck("CS")
			end
			return nil
		end,
		["DS"] = function()
			if cfg.holy<3 then
				return lib.SimpleCDCheck("DS")
			end
			return nil
		end,
		["Inq"] = function()
			local t = lib.GetAura({"Inq"})
			if t<3 then
				return lib.SimpleCDCheck("Inq")
			end
			return nil
		end,
		["Exo"] = function()
			local t = lib.GetAura({"AoW"})
			if t>0 then
				return lib.SimpleCDCheck("Exo")
			end
			return nil
		end,
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
		end,
	}

	return true
end

lib.classevents["PALADIN"] = function()
	cfg.holy=0
	lib.HolyPowerUpdate()
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	lib.rangecheck=function()
		if lib.inrange("CS") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("J") then
			lib.bdcolor(Heddframe.bd,{1,1,0,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.myonupdate = function()
		lib.rangecheck()
		if lib.UpdateSpellCD("HoW") then cfg.Update=true end
	end	
	
	function Heddevents:UNIT_POWER(unit,...)
		if unit=="player" then
			if lib.HolyPowerUpdate() then
				cfg.Update=true
			end
		end
	end

	
--[[	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(unit,spell)
		if unit=="player" and spell==cfg.spells["pest"].name then
			cfg.now = GetTime()
			cfg.lastpest=cfg.now
			cfg.Update=true
		end
	end]]
	
--[[	lib.mytal = function()
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(3,3)
		cfg.destime = (21+4*currRank)
		nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(2,1)
		cfg.rpmax = (100+10*currRank)
	end]]
	
	--	cfg.onpower=true
	cfg.onhealth=true
	cfg.onupdate=true
end